/// <reference types="react" />
/// <reference types="lodash" />
import type { CheckResult } from 'schema-typed';
import { FormInstance } from './useFormRef';
export interface FormErrorProps {
    ref: React.Ref<FormInstance>;
    formValue: any;
    getCombinedModel: () => any;
    onCheck?: (formError: any) => void;
    onError?: (formError: any) => void;
    nestedField?: boolean;
}
export default function useFormValidate(formError: any, props: FormErrorProps): {
    formRef: import("react").RefObject<HTMLFormElement>;
    formError: any;
    check: (...args: any[]) => any;
    setFieldError: (fieldName: string, checkResult: string | CheckResult) => any;
    onRemoveError: (name: string) => import("lodash").Omit<any, string>;
};
