import React from 'react';
import { ItemDataType, WithAsProps } from '../@types/common';
interface SearchViewProps<T> extends WithAsProps {
    searchKeyword: string;
    labelKey: string;
    valueKey: string;
    childrenKey: string;
    value: T[];
    data: ItemDataType<T>[];
    disabledItemValues: any[];
    cascade?: boolean;
    onSearch: (value: string, event: React.ChangeEvent<HTMLInputElement>) => void;
    onCheck: (item: ItemDataType<T>, event: React.SyntheticEvent, checked: boolean) => void;
    inputRef?: React.RefObject<HTMLInputElement>;
}
declare function SearchView<T>(props: SearchViewProps<T>): JSX.Element;
export default SearchView;
